VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "MARV4 LiDAR-estimaattori: V,G,N,H,D r=11.28 m koealat"
   ClientHeight    =   7140
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   9195
   LinkTopic       =   "Form1"
   ScaleHeight     =   7140
   ScaleWidth      =   9195
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   2160
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label Label1 
      Caption         =   "Status"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   4335
   End
   Begin VB.Menu File 
      Caption         =   "File"
      Begin VB.Menu Read_DTM 
         Caption         =   "Step 1. Read DTM"
      End
      Begin VB.Menu Get_elevations_for_plots 
         Caption         =   "Step 2. Get Elevations for Plots"
      End
      Begin VB.Menu Read_Plot_File 
         Caption         =   "Step3. Read Plot locations and estimate"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Get_elevations_for_plots_Click()

Dim no As Long, x As Double, y As Double, z As Double

Open "c:\data\marv4_alat.txt" For Input As 1
Open "c:\data\marv4_alat_heights.txt" For Output As 2
Do Until EOF(1)
Input #1, no, x, y
z = getheight(x, y)
Print #2, Format$(no, "0") & "," & Format$(x, "0.0") & "," & Format$(y, "0.0") & "," & Format$(z, "0.00")
Loop
Close (1)
Close (2)
End Sub

Private Sub Read_DTM_Click()

   Close (1)
   CommonDialog1.DialogTitle = "Header file for a height model"
   CommonDialog1.Filter = "HDR files (*.hdr)|*.hdr"
   CommonDialog1.Action = 1
   DemFileName = CommonDialog1.FileName
   Open DemFileName For Input As 1

   Form1.MousePointer = 11
   DoEvents

Input #1, Zmodel.ncols
Input #1, Zmodel.nrows
Input #1, Zmodel.xllcorner
Input #1, Zmodel.yllcorner
Input #1, Zmodel.CellSize
Input #1, Zmodel.nodata_value
Input #1, Zmodel.filepath

Close (1)

ReDim ZfXY(0 To Zmodel.ncols - 1, 0 To Zmodel.nrows - 1) As Single
ReDim row(0 To Zmodel.ncols - 1) As Single

Dim place As Long

Open Zmodel.filepath For Binary As 1
For i = 0 To Zmodel.nrows - 1
 
Label1.Caption = "Reading DEM ....please wait.." & Format$(i / (Zmodel.nrows - 1) * 100, "#.0") & " % done."
DoEvents
 
 place = 1 + (i * (Zmodel.ncols)) * 4
  Get #1, place, row()
  For j = 0 To Zmodel.ncols - 1
   ZfXY(j, i) = CSng(row(j)) + 0.18
  Next j
 Next i
 Close (1)
RasterModelReady = True
Label1.Caption = " DEM read succesfully"
Form1.MousePointer = 1
DoEvents

End Sub

Private Sub Read_Plot_File_Click()

Open "c:\data\marv4_alat.txt" For Input As 1

ReDim GridCells(1 To 224) As GridCell
Dim HectareString As String * 6
Dim aFileName As String
Dim Npoints As Long, Mp As Long

Dim i As Long, NLabove2 As Long, NFabove2 As Long
Dim Fhmea As Double, Lhmea As Double
Dim Above2FInd As Long, Above2SInd As Long
Dim HFSum As Double, HSSum As Double
Dim HfMax As Double, HSMax As Double, HfMin As Double, HSMin As Double
Dim Fp05 As Double, Fp10 As Double, Fp20 As Double, Fp30 As Double, Fp40 As Double, Fp50 As Double
Dim Fp60 As Double, Fp70 As Double, Fp80 As Double, Fp90 As Double, Fp95 As Double
Dim Fsu05 As Double, Fsu10 As Double, Fsu20 As Double, Fsu30 As Double, Fsu40 As Double, Fsu50 As Double
Dim Fsu60 As Double, Fsu70 As Double, Fsu80 As Double, Fsu90 As Double, Fsu95 As Double
Dim Lp05 As Double, Lp10 As Double, Lp20 As Double, Lp30 As Double, Lp40 As Double, Lp50 As Double
Dim Lp60 As Double, Lp70 As Double, Lp80 As Double, Lp90 As Double, Lp95 As Double
Dim Lsu05 As Double, Lsu10 As Double, Lsu20 As Double, Lsu30 As Double, Lsu40 As Double, Lsu50 As Double
Dim Lsu60 As Double, Lsu70 As Double, Lsu80 As Double, Lsu90 As Double, Lsu95 As Double
Dim Ssum2 As Double, Fsum2 As Double
Dim Fvari As Double, Lvari As Double
Dim Dgsum As Double, Volref As Double, Gref As Double, Treesabove5 As Long, Hgsum As Double
Dim FVariance As Double, SVariance As Double
Dim mx As Long, nx As Long

ReDim Perc(11) As Double
Perc(1) = 0.05: Perc(2) = 0.1: Perc(3) = 0.2: Perc(4) = 0.3: Perc(5) = 0.4: Perc(6) = 0.5
Perc(7) = 0.6: Perc(8) = 0.7: Perc(9) = 0.8: Perc(10) = 0.9: Perc(11) = 0.95

Open "c:\data\Regression_results.txt" For Output As 5
Print #5, "Plot_ID, X, Y, Vol, G, N, HGM, DGM"
Close (5)


Do Until EOF(1)
 Input #1, PlotNumber, x, y
 HectareString = Format$(Int((x - 2514000) / 100), "000") & Format$(Int((y - 6855000) / 100), "000")
 aFileName = "c:\data\als2004\repros\bin\" & Left(HectareString, 3) & "_" & Right(HectareString, 3) & ".bin"
 ReDim LP(1 To MAX_ALL_LP) As ALS_Point
 Open aFileName For Binary As 2
 Mp = 0
 Get #2, , Npoints
 ReDim LPH(1 To Npoints) As ALS_Point_H
   For j = 1 To Npoints
   Mp = Mp + 1
   Get #2, 5 + (j - 1) * 100, LP(Mp)
   LP(Mp).Zs = LP(Mp).Zs + 0.18 ' Correction of wrong GPS-reference height
   LP(Mp).Zf = LP(Mp).Zf + 0.18
  
 Next j
 Close (2)
 Label1.Caption = "Read " & Mp & " laser pulses to global memory"
 ReDim Preserve LP(1 To Mp) As ALS_Point
 
 Label1.Caption = PlotNumber & " Normalizing lidar heights to DTM..."
DoEvents
 
 For i = 1 To Mp
       'LPH(i).GPS_time = LP(i).GPS_time
       'LPH(i).Intf = LP(i).Intf
       'LPH(i).Ints = LP(i).Ints
       'LPH(i).Rangef = LP(i).Rangef
       'LPH(i).Rangel = LP(i).Rangel
       LPH(i).Xs = LP(i).Xs
       LPH(i).Ys = LP(i).Ys
       LPH(i).Zs = LP(i).Zs
       LPH(i).Xf = LP(i).Xf
       LPH(i).Yf = LP(i).Yf
       LPH(i).Zf = LP(i).Zf
       'LPH(i).Scan_angle = LP(i).Scan_angle
   
    If LP(i).Zs < 0 Then MsgBox ("!")
       LPH(i).Hs = 0
       LPH(i).Hf = 0
   Rem Check how many actual returns we have; if less than 3 make first = last
   LPH(i).Hs = LPH(i).Zs - getheight(LPH(i).Xs, LPH(i).Ys)
   If Abs(LP(i).Rangef - LP(i).Rangel) < 3 Or Abs(LP(i).Rangef - LP(i).Rangel) > 40 Then
       LPH(i).Xf = LP(i).Xs
       LPH(i).Yf = LP(i).Ys
       LPH(i).Zf = LP(i).Zs
       LPH(i).Hf = LPH(i).Zf - getheight(LPH(i).Xf, LPH(i).Yf)
   End If
   If (LP(i).Rangel - LP(i).Rangef) >= 3 And (LP(i).Rangel - LP(i).Rangef) < 40 Then
       LPH(i).Hf = LPH(i).Zf - getheight(LPH(i).Xf, LPH(i).Yf)
   End If
       Rem Get heights above ground; some first return points have 0-values in raw data
       Rem These have negative Y-values in KKJ
 
 
m = i
N = PlotNumber

Rem RADIUS

    radius = 11.28
    INOUTFIRST = OUTSIDE
    INOUTLAST = OUTSIDE
     If Sqr((LPH(m).Xs - x) ^ 2 + (LPH(m).Ys - y) ^ 2) < radius Then INOUTFIRST = INSIDE
     If Sqr((LPH(m).Xf - x) ^ 2 + (LPH(m).Yf - y) ^ 2) < radius Then INOUTLAST = INSIDE
     
     If INOUTLAST = INSIDE Or INOUTFIRST = INSIDE Then
       Rem Copy the record; 18 variables
       GridCells(N).InLIdar = GridCells(N).InLIdar + 1
      If INOUTLAST = INSIDE Then
         GridCells(N).InLast = GridCells(N).InLast + 1
         GridCells(N).LPsIn(GridCells(N).InLIdar).InLast = True
      End If
      If INOUTFIRST = INSIDE Then
        GridCells(N).InFirst = GridCells(N).InFirst + 1
        GridCells(N).LPsIn(GridCells(N).InLIdar).InFirst = True
      End If
       
       'GridCells(N).LPsIn(GridCells(N).InLIdar).GPS_time = LPH(m).GPS_time
       'GridCells(N).LPsIn(GridCells(N).InLIdar).Intf = LPH(m).Intf
       'GridCells(N).LPsIn(GridCells(N).InLIdar).Ints = LPH(m).Ints
       'GridCells(N).LPsIn(GridCells(N).InLIdar).Rangef = LPH(m).Rangef
       'GridCells(N).LPsIn(GridCells(N).InLIdar).Rangel = LPH(m).Rangel
       GridCells(N).LPsIn(GridCells(N).InLIdar).Xs = LPH(m).Xs
       GridCells(N).LPsIn(GridCells(N).InLIdar).Ys = LPH(m).Ys
       GridCells(N).LPsIn(GridCells(N).InLIdar).Zs = LPH(m).Zs
       GridCells(N).LPsIn(GridCells(N).InLIdar).Xf = LPH(m).Xf
       GridCells(N).LPsIn(GridCells(N).InLIdar).Yf = LPH(m).Yf
       GridCells(N).LPsIn(GridCells(N).InLIdar).Zf = LPH(m).Zf
       'GridCells(N).LPsIn(GridCells(N).InLIdar).Scan_angle = LPH(m).Scan_angle
       GridCells(N).LPsIn(GridCells(N).InLIdar).Hs = LPH(m).Hs
       GridCells(N).LPsIn(GridCells(N).InLIdar).Hf = LPH(m).Hf
      End If
    

 Next i
 
Close (5)
Open "c:\data\Regression_results.txt" For Append As 5
Dim capu As String
 
 i = N
   
   ReDim HFtau(1 To GridCells(i).InFirst) As Single
   ReDim HFInd(1 To GridCells(i).InFirst) As Long
   ReDim HStau(1 To GridCells(i).InLast) As Single
   ReDim HSInd(1 To GridCells(i).InLast) As Long

 Rem Lets use same notation as in Metstieteen aikakausikirja 4/2005 pp. 413-428
   Rem Fhmea arithmetic mean of normalized heights | (> 2 m) of first pulses
   Rem Lhmea arithmetic mean of normalized heights | (> 2 m) of second (last) pulses
   
   Fhmea = 0:   Lhmea = 0:    NLabove2 = 0:  NFabove2 = 0
   Fsum2 = 0:   Ssum2 = 0
   mx = 0: nx = 0
   Rem Fill the arrays and compute mean values, variance
   For j = 1 To GridCells(i).InLIdar
    If GridCells(i).LPsIn(j).InFirst = True Then
     mx = mx + 1
     HFtau(mx) = GridCells(i).LPsIn(j).Hf
     '  Print #101, i & " " & Format$(GridCells(i).LPsIn(j).Hf, "#.00") & " " & "FP"
     If HFtau(mx) > 2 Then
      Fhmea = Fhmea + HFtau(mx):     NFabove2 = NFabove2 + 1: Fsum2 = Fsum2 + HFtau(mx) ^ 2
     End If
    End If
    
    If GridCells(i).LPsIn(j).InLast = True Then
     nx = nx + 1
     HStau(nx) = GridCells(i).LPsIn(j).Hs
    '  Print #101, i & " " & Format$(GridCells(i).LPsIn(j).Hs, "#.00") & " " & "LP"
     'Print #102, Format$(GridCells(i).LPsIn(j).Xs, "#.00") & "," & Format$(GridCells(i).LPsIn(j).Ys, "#.00") & "," & Format$(GridCells(i).LPsIn(j).Hs, "#.00")
     If HStau(nx) > 2 Then
      Lhmea = Lhmea + HStau(nx):     NLabove2 = NLabove2 + 1: Ssum2 = Ssum2 + HStau(nx) ^ 2
     End If
    End If
   Next j
   
   Rem Sort the tables for computing the percentiles; use heapsort() that is rather quick in-place algorithm
   Call indexx(CLng(UBound(HFtau)), HFtau, HFInd)
   Call indexx(CLng(UBound(HStau)), HStau, HSInd)
   
   Rem Store the total height sums
   HFSum = Fhmea
   HSSum = Lhmea
   
   Rem Variances of aabove 2 m returns
   FVariance = (NFabove2 * Fsum2 - HFSum ^ 2) / (NFabove2 * (NFabove2 - 1))
   SVariance = (NLabove2 * Ssum2 - HSSum ^ 2) / (NLabove2 * (NLabove2 - 1))
   
   Rem Arithmetic means of first and last pulses (> 2 m)
   Fhmea = Fhmea / NFabove2
   Lhmea = Lhmea / NLabove2
   
'   If Fhmea < Lhmea Then MsgBox ("Your Last returns are higher than first returns!")
   
   
   Rem Coefficients of VAR
   Fvari = Sqr(FVariance) / Fhmea
   Lvari = Sqr(SVariance) / Lhmea
   
  
   Rem Vegetation indeces (0..1); by division
   Fvege = NFabove2 / GridCells(i).InFirst
   Lvege = NLabove2 / GridCells(i).InLast
   
 
   
   Rem Minima and maxima of normalized heights for first and last pulses
   HfMax = HFtau(HFInd(UBound(HFtau)))
   HSMax = HStau(HSInd(UBound(HStau)))
   HfMin = HFtau(HFInd(1))
   HSMin = HStau(HSInd(1))
   
   Rem Find the index of first point with height above 2 m
   Above2FInd = 0
   For m = 1 To GridCells(i).InFirst
    If HFtau(HFInd(m)) > 2 Then
      Above2FInd = m: GoTo CheckHstau
    End If
   Next m
CheckHstau:
   If Above2FInd = 0 Or Above2FInd >= GridCells(i).InLIdar Then MsgBox ("Problem in determining Percentiles!")
   Above2SInd = 0
   For m = 1 To GridCells(i).InLast
    If HStau(HSInd(m)) > 2 Then
      Above2SInd = m: GoTo DoneWithAbove2
    End If
   Next m
DoneWithAbove2:
  
   Rem declare arrays that will hold the distribution function (kertymfunktio), (0...1)
   ReDim HFSumtau(1 To GridCells(i).InFirst) As Single
   ReDim HSSumtau(1 To GridCells(i).InLast) As Single
   Rem Declare arrays that hold the sums associated with the percentiles
   ReDim HfPerc(1 To 11, 1 To 3) As Double
   ReDim HSPerc(1 To 11, 1 To 3) As Double
   For m = 1 To 11
    HfPerc(m, 1) = Perc(m) * HFSum
    HSPerc(m, 1) = Perc(m) * HSSum
   Next m


Rem Sum the heights; get the 11 percentiles of 05, 10, 20, 30, 40, 50, 60, 70, 80, 90 and 95%
   kx = 1
   For m = Above2FInd To GridCells(i).InFirst
     HFSumtau(m) = HFSumtau(m - 1) + HFtau(HFInd(m))
     Rem Check if kx'th percentile is reached
     If HFSumtau(m) >= HfPerc(kx, 1) Then
       Rem Height
       HfPerc(kx, 2) = HFtau(HFInd(m))
       Rem proportion of points
       HfPerc(kx, 3) = ((m - Above2FInd) + 1) / CDbl(GridCells(i).InFirst - Above2FInd + 1)
       kx = kx + 1
       If kx > 11 Then GoTo DoneWithFirstReturnPercentiles
    End If
   Next m
DoneWithFirstReturnPercentiles:
Fp05 = HfPerc(1, 2): Fp10 = HfPerc(2, 2): Fp20 = HfPerc(3, 2): Fp30 = HfPerc(4, 2): Fp40 = HfPerc(5, 2):
Fp50 = HfPerc(6, 2): Fp60 = HfPerc(7, 2): Fp70 = HfPerc(8, 2): Fp80 = HfPerc(9, 2): Fp90 = HfPerc(10, 2):
Fp95 = HfPerc(11, 2):
Fsu05 = HfPerc(1, 3): Fsu10 = HfPerc(2, 3): Fsu20 = HfPerc(3, 3): Fsu30 = HfPerc(4, 3): Fsu40 = HfPerc(5, 3):
Fsu50 = HfPerc(6, 3): Fsu60 = HfPerc(7, 3): Fsu70 = HfPerc(8, 3): Fsu80 = HfPerc(9, 3): Fsu90 = HfPerc(10, 3):
Fsu95 = HfPerc(11, 3):



Rem Last returns
   kx = 1
   For m = Above2SInd To GridCells(i).InLast
     HSSumtau(m) = HSSumtau(m - 1) + HStau(HSInd(m))
     Rem Check if kx'th percentile is reached
     If HSSumtau(m) >= HSPerc(kx, 1) Then
       HSPerc(kx, 2) = HStau(HSInd(m))
       HSPerc(kx, 3) = (m - Above2SInd + 1) / CDbl(GridCells(i).InLast - Above2SInd + 1)
       kx = kx + 1
       If kx > 11 Then GoTo DoneWithLastReturnPercentiles
    End If
   Next m
DoneWithLastReturnPercentiles:
Lp05 = HSPerc(1, 2): Lp10 = HSPerc(2, 2): Lp20 = HSPerc(3, 2): Lp30 = HSPerc(4, 2): Lp40 = HSPerc(5, 2):
Lp50 = HSPerc(6, 2): Lp60 = HSPerc(7, 2): Lp70 = HSPerc(8, 2): Lp80 = HSPerc(9, 2): Lp90 = HSPerc(10, 2):
Lp95 = HSPerc(11, 2):
Lsu05 = HSPerc(1, 3): Lsu10 = HSPerc(2, 3): Lsu20 = HSPerc(3, 3): Lsu30 = HSPerc(4, 3): Lsu40 = HSPerc(5, 3):
Lsu50 = HSPerc(6, 3): Lsu60 = HSPerc(7, 3): Lsu70 = HSPerc(8, 3): Lsu80 = HSPerc(9, 3): Lsu90 = HSPerc(10, 3):
Lsu95 = HSPerc(11, 3):

   capu = capu & Format$(GridCells(i).InFirst, "#") & ","
   capu = capu & Format$(GridCells(i).InLast, "#") & ","
   capu = capu & Format$(NFabove2, "#") & ","
   capu = capu & Format$(NLabove2, "#") & ","
   capu = capu & Format$(Fhmea, "#.00") & ","
   capu = capu & Format$(Lhmea, "#.00") & ","
   capu = capu & Format$(Fvari, "#.00") & ","
   capu = capu & Format$(Lvari, "#.00") & ","
   capu = capu & Format$(Fvege, "#.000") & ","
   capu = capu & Format$(Lvege, "#.000") & ","
   capu = capu & Format$(Fp05, "#.00") & ","
   capu = capu & Format$(Fp10, "#.00") & ","
   capu = capu & Format$(Fp20, "#.00") & ","
   capu = capu & Format$(Fp30, "#.00") & ","
   capu = capu & Format$(Fp40, "#.00") & ","
   capu = capu & Format$(Fp50, "#.00") & ","
   capu = capu & Format$(Fp60, "#.00") & ","
   capu = capu & Format$(Fp70, "#.00") & ","
   capu = capu & Format$(Fp80, "#.00") & ","
   capu = capu & Format$(Fp90, "#.00") & ","
   capu = capu & Format$(Fp95, "#.00") & ","
   capu = capu & Format$(Fsu05, "#.000") & ","
   capu = capu & Format$(Fsu10, "#.000") & ","
   capu = capu & Format$(Fsu20, "#.000") & ","
   capu = capu & Format$(Fsu30, "#.000") & ","
   capu = capu & Format$(Fsu40, "#.000") & ","
   capu = capu & Format$(Fsu50, "#.000") & ","
   capu = capu & Format$(Fsu60, "#.000") & ","
   capu = capu & Format$(Fsu70, "#.000") & ","
   capu = capu & Format$(Fsu80, "#.000") & ","
   capu = capu & Format$(Fsu90, "#.000") & ","
   capu = capu & Format$(Fsu95, "#.000") & ","
   capu = capu & Format$(Lp05, "#.00") & ","
   capu = capu & Format$(Lp10, "#.00") & ","
   capu = capu & Format$(Lp20, "#.00") & ","
   capu = capu & Format$(Lp30, "#.00") & ","
   capu = capu & Format$(Lp40, "#.00") & ","
   capu = capu & Format$(Lp50, "#.00") & ","
   capu = capu & Format$(Lp60, "#.00") & ","
   capu = capu & Format$(Lp70, "#.00") & ","
   capu = capu & Format$(Lp80, "#.00") & ","
   capu = capu & Format$(Lp90, "#.00") & ","
   capu = capu & Format$(Lp95, "#.00") & ","
   capu = capu & Format$(Lsu05, "#.000") & ","
   capu = capu & Format$(Lsu10, "#.000") & ","
   capu = capu & Format$(Lsu20, "#.000") & ","
   capu = capu & Format$(Lsu30, "#.000") & ","
   capu = capu & Format$(Lsu40, "#.000") & ","
   capu = capu & Format$(Lsu50, "#.000") & ","
   capu = capu & Format$(Lsu60, "#.000") & ","
   capu = capu & Format$(Lsu70, "#.000") & ","
   capu = capu & Format$(Lsu80, "#.000") & ","
   capu = capu & Format$(Lsu90, "#.000") & ","
   capu = capu & Format$(Lsu95, "#.000") & ","


Rem regression for Volume
 LNV = 0.788 + 0.704 * Log(Fp50) + 1.09 * Sqr(Fvege) + 0.735 * Log(Lhmea) + 0.267 * Log(Lvege) + (0.02887 + 0.00781) / 2
 Volume = Exp(LNV)
 SQRG = -0.795 + 1.329 * Log(Fhmea) + 1.342 * Fvege + 2.27 * Sqr(Lvege) - 1.773 * (1 / Fp05)
 BasalArea = (SQRG) ^ 2 + (0.13199 + 0.02987)
 N = 11376.75 + 1556.143 * ((Lvege) ^ 2) + 1036.063 * (Fvege ^ 2) - 4.214 * (Lhmea ^ 2) - 5777.637 * (Fsu50 ^ 2) - 5755.064 * (1 / Lsu70) - 1471.856 * Sqr(Lvari)
 SQRHGM = 0.95 + 0.594 * Sqr(Fp80) + 0.055 * Fp60
 HGM = SQRHGM ^ 2 + (0.02877 + 0.00157)
 LNDGM = 2.97 + 0.44 * Sqr(Lp70) - 0.383 * Sqr(Fp20) - 0.337 * (Fvege ^ 2) + 0.409 * Sqr(Fp50) - 1.9 * Sqr(Lsu70) - 0.052 * (1 / Lvege) + (0.01452 + 0.00325) / 2
 DGM = Exp(LNDGM)
   Rem Volume of reference trees
   Volref = 0: Gref = 0: Treesabove5 = 0: Hgsum = 0: Dgsum = 0
   'For m = 1 To GridCells(i).InTrees
   ' Volref = Volref + GridCells(i).TreeIn(m).Vol
   ' Gref = Gref + GridCells(i).TreeIn(m).d13 ^ 2
  '  If GridCells(i).TreeIn(m).d13 > 5 Then Treesabove5 = Treesabove5 + 1
  '  Hgsum = Hgsum + GridCells(i).TreeIn(m).h * (GridCells(i).TreeIn(m).d13) ^ 2
  '  Dgsum = Dgsum + GridCells(i).TreeIn(m).d13 ^ 3
  ' Next m
   'Hg = Hgsum / Gref
   'Dg = Dgsum / Gref
   'Gref = (Gref * 3.1415 / 4) * (10000 / (GridWidth * GridWidth)) / 10000
   'Volref = Volref * (10000 / (GridWidth * GridWidth)) / 1000
   'Nref = Treesabove5 * (10000 / (GridWidth * GridWidth))
   capu = ""
   capu = capu & Format$(Volume, "#.0") & ","
   capu = capu & Format$(BasalArea, "#.0") & ","
   capu = capu & Format$(N, "#") & ","
   capu = capu & Format$(HGM, "#.0") & ","
   capu = capu & Format$(DGM, "#.0") & ","
      
'   Print #103, i & "," & capu

   
   Print #5, Format$(PlotNumber, "000") & "," & Format$(x, "0.00") & "," & Format$(y, "0.00") & "," & capu
'   For j = 1 To GridCells(i).InLIdar
'    xx = Hftau(HfInd(j))
'    xx = HsTau(HfInd(j))
'   Next j
   
           
'  End If

Label1.Caption = "Normalized heights sorted and percentiles computed"
Close (5)
 Close (103):  Close (101): Close (102)

 
 
  
  
 
 
 
Rem Free memory; i.e. get rid of LP() -structure; make it an array with two elements
ReDim Preserve LP(1 To 2) As ALS_Point
Label1.Caption = PlotNumber & " Ground normalized heights computed!; DONE ESTIMATION!"
 
 
Loop
Close (1)

End Sub
